import { SelectionRange, Line } from "@codemirror/state";
export declare enum Direction {
    LTR = 0,
    RTL = 1
}
export declare class BidiSpan {
    readonly from: number;
    readonly to: number;
    readonly level: number;
    get dir(): Direction;
    constructor(from: number, to: number, level: number);
    side(end: boolean, dir: Direction): number;
    static find(order: readonly BidiSpan[], index: number, level: number, assoc: number): number;
}
export declare type Isolate = {
    from: number;
    to: number;
    direction: Direction;
    inner: readonly Isolate[];
};
export declare function isolatesEq(a: readonly Isolate[], b: readonly Isolate[]): boolean;
export declare function computeOrder(line: string, direction: Direction, isolates: readonly Isolate[]): BidiSpan[];
export declare function trivialOrder(length: number): BidiSpan[];
export declare let movedOver: string;
export declare function moveVisually(line: Line, order: readonly BidiSpan[], dir: Direction, start: SelectionRange, forward: boolean): SelectionRange;
