import { ContentView, ChildCursor, DOMPos } from "./contentview";
import { BlockView } from "./blockview";
import { DecorationSet } from "./decoration";
import { Rect } from "./dom";
import { ViewUpdate, ScrollTarget } from "./extension";
import { EditorView } from "./editorview";
import { Direction } from "./bidi";
export declare class DocView extends ContentView {
    readonly view: EditorView;
    children: BlockView[];
    decorations: readonly DecorationSet[];
    dynamicDecorationMap: boolean[];
    hasComposition: {
        from: number;
        to: number;
    } | null;
    markedForComposition: Set<ContentView>;
    minWidth: number;
    minWidthFrom: number;
    minWidthTo: number;
    impreciseAnchor: DOMPos | null;
    impreciseHead: DOMPos | null;
    forceSelection: boolean;
    dom: HTMLElement;
    lastUpdate: number;
    get length(): number;
    constructor(view: EditorView);
    update(update: ViewUpdate): boolean;
    private updateInner;
    private updateChildren;
    private compositionView;
    private fixCompositionDOM;
    updateSelection(mustRead?: boolean, fromPointer?: boolean): void;
    enforceCursorAssoc(): void;
    nearest(dom: Node): ContentView | null;
    posFromDOM(node: Node, offset: number): number;
    domAtPos(pos: number): DOMPos;
    coordsAt(pos: number, side: number): Rect | null;
    coordsForChar(pos: number): DOMRect;
    measureVisibleLineHeights(viewport: {
        from: number;
        to: number;
    }): any[];
    textDirectionAt(pos: number): Direction;
    measureTextSize(): {
        lineHeight: number;
        charWidth: number;
        textHeight: number;
    };
    childCursor(pos?: number): ChildCursor;
    computeBlockGapDeco(): DecorationSet;
    updateDeco(): DecorationSet[];
    scrollIntoView(target: ScrollTarget): void;
    split: () => ContentView;
}
export declare function findCompositionNode(view: EditorView, dLen: number): {
    from: number;
    to: number;
    node: Text;
} | null;
