import { EditorView } from "./editorview";
import { DOMSelectionState } from "./dom";
import { DOMChange } from "./domchange";
export declare class DOMObserver {
    private view;
    dom: HTMLElement;
    win: Window;
    observer: MutationObserver;
    active: boolean;
    selectionRange: DOMSelectionState;
    selectionChanged: boolean;
    delayedFlush: number;
    resizeTimeout: number;
    queue: MutationRecord[];
    delayedAndroidKey: {
        key: string;
        keyCode: number;
        force: boolean;
    } | null;
    flushingAndroidKey: number;
    lastChange: number;
    onCharData: any;
    scrollTargets: HTMLElement[];
    intersection: IntersectionObserver | null;
    resizeScroll: ResizeObserver | null;
    resizeContent: ResizeObserver | null;
    intersecting: boolean;
    gapIntersection: IntersectionObserver | null;
    gaps: readonly HTMLElement[];
    parentCheck: number;
    constructor(view: EditorView);
    onScrollChanged(e: Event): void;
    onScroll(e: Event): void;
    onResize(): void;
    onPrint(): void;
    updateGaps(gaps: readonly HTMLElement[]): void;
    onSelectionChange(event: Event): void;
    readSelectionRange(): boolean;
    setSelectionRange(anchor: {
        node: Node;
        offset: number;
    }, head: {
        node: Node;
        offset: number;
    }): void;
    clearSelectionRange(): void;
    listenForScroll(): void;
    ignore<T>(f: () => T): T;
    start(): void;
    stop(): void;
    clear(): void;
    delayAndroidKey(key: string, keyCode: number): void;
    clearDelayedAndroidKey(): void;
    flushSoon(): void;
    forceFlush(): void;
    pendingRecords(): MutationRecord[];
    processRecords(): {
        from: number;
        to: number;
        typeOver: boolean;
    };
    readChange(): DOMChange;
    flush(readSelection?: boolean): boolean;
    readMutation(rec: MutationRecord): {
        from: number;
        to: number;
        typeOver: boolean;
    } | null;
    setWindow(win: Window): void;
    addWindowListeners(win: Window): void;
    removeWindowListeners(win: Window): void;
    destroy(): void;
}
