import { Extension, SelectionRange } from "@codemirror/state";
import { ViewUpdate } from "./extension";
import { EditorView } from "./editorview";
export interface LayerMarker {
    eq(other: LayerMarker): boolean;
    draw(): HTMLElement;
    update?(dom: HTMLElement, oldMarker: LayerMarker): boolean;
}
export declare class RectangleMarker implements LayerMarker {
    private className;
    private left;
    private top;
    private width;
    private height;
    constructor(className: string, left: number, top: number, width: number | null, height: number);
    draw(): HTMLDivElement;
    update(elt: HTMLElement, prev: RectangleMarker): boolean;
    private adjust;
    eq(p: RectangleMarker): boolean;
    static forRange(view: EditorView, className: string, range: SelectionRange): readonly RectangleMarker[];
}
interface LayerConfig {
    above: boolean;
    class?: string;
    update(update: ViewUpdate, layer: HTMLElement): boolean;
    markers(view: EditorView): readonly LayerMarker[];
    mount?(layer: HTMLElement, view: EditorView): void;
    destroy?(layer: HTMLElement, view: EditorView): void;
}
export declare function layer(config: LayerConfig): Extension;
export {};
