import { Facet, Extension } from "@codemirror/state";
import { EditorView } from "./editorview";
import { ViewUpdate } from "./extension";
declare type PanelConfig = {
    topContainer?: HTMLElement;
    bottomContainer?: HTMLElement;
};
export declare function panels(config?: PanelConfig): Extension;
export interface Panel {
    dom: HTMLElement;
    mount?(): void;
    update?(update: ViewUpdate): void;
    destroy?(): void;
    top?: boolean;
}
export declare function getPanel(view: EditorView, panel: PanelConstructor): Panel;
export declare type PanelConstructor = (view: EditorView) => Panel;
export declare const showPanel: Facet<PanelConstructor, readonly PanelConstructor[]>;
export {};
