import { EditorState, Transaction, StateEffect, Facet, Extension } from "@codemirror/state";
import { EditorView } from "./editorview";
import { ViewUpdate } from "./extension";
import { Rect } from "./dom";
export declare function tooltips(config?: {
    position?: "fixed" | "absolute";
    parent?: HTMLElement;
    tooltipSpace?: (view: EditorView) => Rect;
}): Extension;
export interface Tooltip {
    pos: number;
    end?: number;
    create(view: EditorView): TooltipView;
    above?: boolean;
    strictSide?: boolean;
    arrow?: boolean;
}
export interface TooltipView {
    dom: HTMLElement;
    offset?: {
        x: number;
        y: number;
    };
    getCoords?: (pos: number) => Rect;
    overlap?: boolean;
    mount?(view: EditorView): void;
    update?(update: ViewUpdate): void;
    destroy?(): void;
    positioned?(space: Rect): void;
    resize?: boolean;
}
export declare const showTooltip: Facet<Tooltip, readonly Tooltip[]>;
export declare function hoverTooltip(source: (view: EditorView, pos: number, side: -1 | 1) => Tooltip | null | Promise<Tooltip | null>, options?: {
    hideOn?: (tr: Transaction, tooltip: Tooltip) => boolean;
    hideOnChange?: boolean | "touch";
    hoverTime?: number;
}): Extension;
export declare function getTooltip(view: EditorView, tooltip: Tooltip): TooltipView | null;
export declare function hasHoverTooltips(state: EditorState): boolean;
export declare const closeHoverTooltips: StateEffect<null>;
export declare function repositionTooltips(view: EditorView): void;
